# pokeapiclient
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 20220523
- Package version: 0.9.1
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/cliffano/pokeapi-clients.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/cliffano/pokeapi-clients.git`)

Then import the package:
```python
import pokeapiclient
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import pokeapiclient
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import pokeapiclient
from pprint import pprint
from pokeapiclient.api import ability_api
# Defining the host is optional and defaults to https://pokeapi.co
# See configuration.py for a list of all supported configuration parameters.
configuration = pokeapiclient.Configuration(
    host = "https://pokeapi.co"
)



# Enter a context with an instance of the API client
with pokeapiclient.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ability_api.AbilityApi(api_client)
    limit = 1 # int |  (optional)
offset = 1 # int |  (optional)

    try:
        api_response = api_instance.ability_list(limit=limit, offset=offset)
        pprint(api_response)
    except pokeapiclient.ApiException as e:
        print("Exception when calling AbilityApi->ability_list: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://pokeapi.co*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AbilityApi* | [**ability_list**](docs/AbilityApi.md#ability_list) | **GET** /api/v2/ability/ | 
*AbilityApi* | [**ability_read**](docs/AbilityApi.md#ability_read) | **GET** /api/v2/ability/{id}/ | 
*BerryApi* | [**berry_list**](docs/BerryApi.md#berry_list) | **GET** /api/v2/berry/ | 
*BerryApi* | [**berry_read**](docs/BerryApi.md#berry_read) | **GET** /api/v2/berry/{id}/ | 
*BerryFirmnessApi* | [**berry_firmness_list**](docs/BerryFirmnessApi.md#berry_firmness_list) | **GET** /api/v2/berry-firmness/ | 
*BerryFirmnessApi* | [**berry_firmness_read**](docs/BerryFirmnessApi.md#berry_firmness_read) | **GET** /api/v2/berry-firmness/{id}/ | 
*BerryFlavorApi* | [**berry_flavor_list**](docs/BerryFlavorApi.md#berry_flavor_list) | **GET** /api/v2/berry-flavor/ | 
*BerryFlavorApi* | [**berry_flavor_read**](docs/BerryFlavorApi.md#berry_flavor_read) | **GET** /api/v2/berry-flavor/{id}/ | 
*CharacteristicApi* | [**characteristic_list**](docs/CharacteristicApi.md#characteristic_list) | **GET** /api/v2/characteristic/ | 
*CharacteristicApi* | [**characteristic_read**](docs/CharacteristicApi.md#characteristic_read) | **GET** /api/v2/characteristic/{id}/ | 
*ContestEffectApi* | [**contest_effect_list**](docs/ContestEffectApi.md#contest_effect_list) | **GET** /api/v2/contest-effect/ | 
*ContestEffectApi* | [**contest_effect_read**](docs/ContestEffectApi.md#contest_effect_read) | **GET** /api/v2/contest-effect/{id}/ | 
*ContestTypeApi* | [**contest_type_list**](docs/ContestTypeApi.md#contest_type_list) | **GET** /api/v2/contest-type/ | 
*ContestTypeApi* | [**contest_type_read**](docs/ContestTypeApi.md#contest_type_read) | **GET** /api/v2/contest-type/{id}/ | 
*EggGroupApi* | [**egg_group_list**](docs/EggGroupApi.md#egg_group_list) | **GET** /api/v2/egg-group/ | 
*EggGroupApi* | [**egg_group_read**](docs/EggGroupApi.md#egg_group_read) | **GET** /api/v2/egg-group/{id}/ | 
*EncounterConditionApi* | [**encounter_condition_list**](docs/EncounterConditionApi.md#encounter_condition_list) | **GET** /api/v2/encounter-condition/ | 
*EncounterConditionApi* | [**encounter_condition_read**](docs/EncounterConditionApi.md#encounter_condition_read) | **GET** /api/v2/encounter-condition/{id}/ | 
*EncounterConditionValueApi* | [**encounter_condition_value_list**](docs/EncounterConditionValueApi.md#encounter_condition_value_list) | **GET** /api/v2/encounter-condition-value/ | 
*EncounterConditionValueApi* | [**encounter_condition_value_read**](docs/EncounterConditionValueApi.md#encounter_condition_value_read) | **GET** /api/v2/encounter-condition-value/{id}/ | 
*EncounterMethodApi* | [**encounter_method_list**](docs/EncounterMethodApi.md#encounter_method_list) | **GET** /api/v2/encounter-method/ | 
*EncounterMethodApi* | [**encounter_method_read**](docs/EncounterMethodApi.md#encounter_method_read) | **GET** /api/v2/encounter-method/{id}/ | 
*EvolutionChainApi* | [**evolution_chain_list**](docs/EvolutionChainApi.md#evolution_chain_list) | **GET** /api/v2/evolution-chain/ | 
*EvolutionChainApi* | [**evolution_chain_read**](docs/EvolutionChainApi.md#evolution_chain_read) | **GET** /api/v2/evolution-chain/{id}/ | 
*EvolutionTriggerApi* | [**evolution_trigger_list**](docs/EvolutionTriggerApi.md#evolution_trigger_list) | **GET** /api/v2/evolution-trigger/ | 
*EvolutionTriggerApi* | [**evolution_trigger_read**](docs/EvolutionTriggerApi.md#evolution_trigger_read) | **GET** /api/v2/evolution-trigger/{id}/ | 
*GenderApi* | [**gender_list**](docs/GenderApi.md#gender_list) | **GET** /api/v2/gender/ | 
*GenderApi* | [**gender_read**](docs/GenderApi.md#gender_read) | **GET** /api/v2/gender/{id}/ | 
*GenerationApi* | [**generation_list**](docs/GenerationApi.md#generation_list) | **GET** /api/v2/generation/ | 
*GenerationApi* | [**generation_read**](docs/GenerationApi.md#generation_read) | **GET** /api/v2/generation/{id}/ | 
*GrowthRateApi* | [**growth_rate_list**](docs/GrowthRateApi.md#growth_rate_list) | **GET** /api/v2/growth-rate/ | 
*GrowthRateApi* | [**growth_rate_read**](docs/GrowthRateApi.md#growth_rate_read) | **GET** /api/v2/growth-rate/{id}/ | 
*ItemApi* | [**item_list**](docs/ItemApi.md#item_list) | **GET** /api/v2/item/ | 
*ItemApi* | [**item_read**](docs/ItemApi.md#item_read) | **GET** /api/v2/item/{id}/ | 
*ItemAttributeApi* | [**item_attribute_list**](docs/ItemAttributeApi.md#item_attribute_list) | **GET** /api/v2/item-attribute/ | 
*ItemAttributeApi* | [**item_attribute_read**](docs/ItemAttributeApi.md#item_attribute_read) | **GET** /api/v2/item-attribute/{id}/ | 
*ItemCategoryApi* | [**item_category_list**](docs/ItemCategoryApi.md#item_category_list) | **GET** /api/v2/item-category/ | 
*ItemCategoryApi* | [**item_category_read**](docs/ItemCategoryApi.md#item_category_read) | **GET** /api/v2/item-category/{id}/ | 
*ItemFlingEffectApi* | [**item_fling_effect_list**](docs/ItemFlingEffectApi.md#item_fling_effect_list) | **GET** /api/v2/item-fling-effect/ | 
*ItemFlingEffectApi* | [**item_fling_effect_read**](docs/ItemFlingEffectApi.md#item_fling_effect_read) | **GET** /api/v2/item-fling-effect/{id}/ | 
*ItemPocketApi* | [**item_pocket_list**](docs/ItemPocketApi.md#item_pocket_list) | **GET** /api/v2/item-pocket/ | 
*ItemPocketApi* | [**item_pocket_read**](docs/ItemPocketApi.md#item_pocket_read) | **GET** /api/v2/item-pocket/{id}/ | 
*LanguageApi* | [**language_list**](docs/LanguageApi.md#language_list) | **GET** /api/v2/language/ | 
*LanguageApi* | [**language_read**](docs/LanguageApi.md#language_read) | **GET** /api/v2/language/{id}/ | 
*LocationApi* | [**location_list**](docs/LocationApi.md#location_list) | **GET** /api/v2/location/ | 
*LocationApi* | [**location_read**](docs/LocationApi.md#location_read) | **GET** /api/v2/location/{id}/ | 
*LocationAreaApi* | [**location_area_list**](docs/LocationAreaApi.md#location_area_list) | **GET** /api/v2/location-area/ | 
*LocationAreaApi* | [**location_area_read**](docs/LocationAreaApi.md#location_area_read) | **GET** /api/v2/location-area/{id}/ | 
*MachineApi* | [**machine_list**](docs/MachineApi.md#machine_list) | **GET** /api/v2/machine/ | 
*MachineApi* | [**machine_read**](docs/MachineApi.md#machine_read) | **GET** /api/v2/machine/{id}/ | 
*MoveApi* | [**move_list**](docs/MoveApi.md#move_list) | **GET** /api/v2/move/ | 
*MoveApi* | [**move_read**](docs/MoveApi.md#move_read) | **GET** /api/v2/move/{id}/ | 
*MoveAilmentApi* | [**move_ailment_list**](docs/MoveAilmentApi.md#move_ailment_list) | **GET** /api/v2/move-ailment/ | 
*MoveAilmentApi* | [**move_ailment_read**](docs/MoveAilmentApi.md#move_ailment_read) | **GET** /api/v2/move-ailment/{id}/ | 
*MoveBattleStyleApi* | [**move_battle_style_list**](docs/MoveBattleStyleApi.md#move_battle_style_list) | **GET** /api/v2/move-battle-style/ | 
*MoveBattleStyleApi* | [**move_battle_style_read**](docs/MoveBattleStyleApi.md#move_battle_style_read) | **GET** /api/v2/move-battle-style/{id}/ | 
*MoveCategoryApi* | [**move_category_list**](docs/MoveCategoryApi.md#move_category_list) | **GET** /api/v2/move-category/ | 
*MoveCategoryApi* | [**move_category_read**](docs/MoveCategoryApi.md#move_category_read) | **GET** /api/v2/move-category/{id}/ | 
*MoveDamageClassApi* | [**move_damage_class_list**](docs/MoveDamageClassApi.md#move_damage_class_list) | **GET** /api/v2/move-damage-class/ | 
*MoveDamageClassApi* | [**move_damage_class_read**](docs/MoveDamageClassApi.md#move_damage_class_read) | **GET** /api/v2/move-damage-class/{id}/ | 
*MoveLearnMethodApi* | [**move_learn_method_list**](docs/MoveLearnMethodApi.md#move_learn_method_list) | **GET** /api/v2/move-learn-method/ | 
*MoveLearnMethodApi* | [**move_learn_method_read**](docs/MoveLearnMethodApi.md#move_learn_method_read) | **GET** /api/v2/move-learn-method/{id}/ | 
*MoveTargetApi* | [**move_target_list**](docs/MoveTargetApi.md#move_target_list) | **GET** /api/v2/move-target/ | 
*MoveTargetApi* | [**move_target_read**](docs/MoveTargetApi.md#move_target_read) | **GET** /api/v2/move-target/{id}/ | 
*NatureApi* | [**nature_list**](docs/NatureApi.md#nature_list) | **GET** /api/v2/nature/ | 
*NatureApi* | [**nature_read**](docs/NatureApi.md#nature_read) | **GET** /api/v2/nature/{id}/ | 
*PalParkAreaApi* | [**pal_park_area_list**](docs/PalParkAreaApi.md#pal_park_area_list) | **GET** /api/v2/pal-park-area/ | 
*PalParkAreaApi* | [**pal_park_area_read**](docs/PalParkAreaApi.md#pal_park_area_read) | **GET** /api/v2/pal-park-area/{id}/ | 
*PokeathlonStatApi* | [**pokeathlon_stat_list**](docs/PokeathlonStatApi.md#pokeathlon_stat_list) | **GET** /api/v2/pokeathlon-stat/ | 
*PokeathlonStatApi* | [**pokeathlon_stat_read**](docs/PokeathlonStatApi.md#pokeathlon_stat_read) | **GET** /api/v2/pokeathlon-stat/{id}/ | 
*PokedexApi* | [**pokedex_list**](docs/PokedexApi.md#pokedex_list) | **GET** /api/v2/pokedex/ | 
*PokedexApi* | [**pokedex_read**](docs/PokedexApi.md#pokedex_read) | **GET** /api/v2/pokedex/{id}/ | 
*PokemonApi* | [**pokemon_list**](docs/PokemonApi.md#pokemon_list) | **GET** /api/v2/pokemon/ | 
*PokemonApi* | [**pokemon_read**](docs/PokemonApi.md#pokemon_read) | **GET** /api/v2/pokemon/{id}/ | 
*PokemonColorApi* | [**pokemon_color_list**](docs/PokemonColorApi.md#pokemon_color_list) | **GET** /api/v2/pokemon-color/ | 
*PokemonColorApi* | [**pokemon_color_read**](docs/PokemonColorApi.md#pokemon_color_read) | **GET** /api/v2/pokemon-color/{id}/ | 
*PokemonFormApi* | [**pokemon_form_list**](docs/PokemonFormApi.md#pokemon_form_list) | **GET** /api/v2/pokemon-form/ | 
*PokemonFormApi* | [**pokemon_form_read**](docs/PokemonFormApi.md#pokemon_form_read) | **GET** /api/v2/pokemon-form/{id}/ | 
*PokemonHabitatApi* | [**pokemon_habitat_list**](docs/PokemonHabitatApi.md#pokemon_habitat_list) | **GET** /api/v2/pokemon-habitat/ | 
*PokemonHabitatApi* | [**pokemon_habitat_read**](docs/PokemonHabitatApi.md#pokemon_habitat_read) | **GET** /api/v2/pokemon-habitat/{id}/ | 
*PokemonShapeApi* | [**pokemon_shape_list**](docs/PokemonShapeApi.md#pokemon_shape_list) | **GET** /api/v2/pokemon-shape/ | 
*PokemonShapeApi* | [**pokemon_shape_read**](docs/PokemonShapeApi.md#pokemon_shape_read) | **GET** /api/v2/pokemon-shape/{id}/ | 
*PokemonSpeciesApi* | [**pokemon_species_list**](docs/PokemonSpeciesApi.md#pokemon_species_list) | **GET** /api/v2/pokemon-species/ | 
*PokemonSpeciesApi* | [**pokemon_species_read**](docs/PokemonSpeciesApi.md#pokemon_species_read) | **GET** /api/v2/pokemon-species/{id}/ | 
*RegionApi* | [**region_list**](docs/RegionApi.md#region_list) | **GET** /api/v2/region/ | 
*RegionApi* | [**region_read**](docs/RegionApi.md#region_read) | **GET** /api/v2/region/{id}/ | 
*StatApi* | [**stat_list**](docs/StatApi.md#stat_list) | **GET** /api/v2/stat/ | 
*StatApi* | [**stat_read**](docs/StatApi.md#stat_read) | **GET** /api/v2/stat/{id}/ | 
*SuperContestEffectApi* | [**super_contest_effect_list**](docs/SuperContestEffectApi.md#super_contest_effect_list) | **GET** /api/v2/super-contest-effect/ | 
*SuperContestEffectApi* | [**super_contest_effect_read**](docs/SuperContestEffectApi.md#super_contest_effect_read) | **GET** /api/v2/super-contest-effect/{id}/ | 
*TypeApi* | [**type_list**](docs/TypeApi.md#type_list) | **GET** /api/v2/type/ | 
*TypeApi* | [**type_read**](docs/TypeApi.md#type_read) | **GET** /api/v2/type/{id}/ | 
*VersionApi* | [**version_list**](docs/VersionApi.md#version_list) | **GET** /api/v2/version/ | 
*VersionApi* | [**version_read**](docs/VersionApi.md#version_read) | **GET** /api/v2/version/{id}/ | 
*VersionGroupApi* | [**version_group_list**](docs/VersionGroupApi.md#version_group_list) | **GET** /api/v2/version-group/ | 
*VersionGroupApi* | [**version_group_read**](docs/VersionGroupApi.md#version_group_read) | **GET** /api/v2/version-group/{id}/ | 


## Documentation For Models



## Documentation For Authorization

 All endpoints do not require authorization.

## Author




## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in pokeapiclient.apis and pokeapiclient.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from pokeapiclient.api.default_api import DefaultApi`
- `from pokeapiclient.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import pokeapiclient
from pokeapiclient.apis import *
from pokeapiclient.models import *
```

